<?php
/**
*
* @author oxpus (Karsten Ude) webmaster@oxpus.net
* @package download mod convert package based on umil (c) 2008 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// We only allow a founder install this MOD
if ($user->data['user_type'] != USER_FOUNDER)
{
    login_box('', 'LOGIN');
}

if (!class_exists('umil'))
{
	include($phpbb_root_path . 'umil/umil.' . $phpEx);
}

// If you want a completely stand alone version (able to use UMIL without messing with any of the language stuff) send true, otherwise send false
$umil = new umil(true);

$dl_version = dl_config_exists('dl_mod_version', true);

if (!$dl_version || $dl_version < '5.2.0' || $dl_version{0} == '6')
{
	trigger_error('No Download Mod found!<br />Stop converting...<hr />' . $dl_version);
}

if (confirm_box(true))
{
	$umil->table_column_add(DL_CAT_TABLE, 'desc_uid', array('CHAR:8', ''));
	$umil->table_column_add(DL_CAT_TABLE, 'desc_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DL_CAT_TABLE, 'desc_flags', array('UINT:11', 0));
	$umil->table_column_add(DL_CAT_TABLE, 'rules_uid', array('CHAR:8', ''));
	$umil->table_column_add(DL_CAT_TABLE, 'rules_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DL_CAT_TABLE, 'rules_flags', array('UINT:11', 0));
	
	$umil->table_column_add(DOWNLOADS_TABLE, 'mod_desc_uid', array('CHAR:8', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'mod_desc_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'mod_desc_flags', array('UINT:11', 0));
	$umil->table_column_add(DOWNLOADS_TABLE, 'long_desc_uid', array('CHAR:8', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'long_desc_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'long_desc_flags', array('UINT:11', 0));
	$umil->table_column_add(DOWNLOADS_TABLE, 'desc_uid', array('CHAR:8', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'desc_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'desc_flags', array('UINT:11', 0));
	$umil->table_column_add(DOWNLOADS_TABLE, 'warn_uid', array('CHAR:8', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'warn_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DOWNLOADS_TABLE, 'warn_flags', array('UINT:11', 0));
	
	$umil->table_column_add(DL_COMMENTS_TABLE, 'com_uid', array('CHAR:8', ''));
	$umil->table_column_add(DL_COMMENTS_TABLE, 'com_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DL_COMMENTS_TABLE, 'com_flags', array('UINT:11', 0));
	
	$umil->table_column_add(DL_BUGS_TABLE, 'bug_uid', array('CHAR:8', ''));
	$umil->table_column_add(DL_BUGS_TABLE, 'bug_bitfield', array('VCHAR', ''));
	$umil->table_column_add(DL_BUGS_TABLE, 'bug_flags', array('UINT:11', 0));

	$sql = array();

	$sql[] = "UPDATE " . DL_BUGS_TABLE . " SET bug_uid = 'x', report_text = REPLACE(report_text, CONCAT(':', report_uid),'') WHERE report_uid <> '' AND report_text <> REPLACE(report_text, CONCAT(':', report_uid),'')";
	$sql[] = "UPDATE " . DL_COMMENTS_TABLE . " SET com_uid = 'x', comment_text = REPLACE(comment_text, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND comment_text <> REPLACE(comment_text, CONCAT(':', bbcode_uid),'')";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET desc_uid = 'x', description = REPLACE(description, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND description <> REPLACE(description, CONCAT(':', bbcode_uid),'')";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET long_desc_uid = 'x', long_desc = REPLACE(long_desc, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND long_desc <> REPLACE(long_desc, CONCAT(':', bbcode_uid),'')";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET mod_desc_uid = 'x', mod_desc = REPLACE(mod_desc, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND mod_desc <> REPLACE(mod_desc, CONCAT(':', bbcode_uid),'')";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET warn_uid = 'x', warning = REPLACE(warning, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND warning <> REPLACE(warning, CONCAT(':', bbcode_uid),'')";
	$sql[] = "UPDATE " . DL_CAT_TABLE . " SET desc_uid = 'x', description = REPLACE(description, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND description <> REPLACE(description, CONCAT(':', bbcode_uid),'')";
	$sql[] = "UPDATE " . DL_CAT_TABLE . " SET rules_uid = 'x', rules = REPLACE(rules, CONCAT(':', bbcode_uid),'') WHERE bbcode_uid <> '' AND rules <> REPLACE(rules, CONCAT(':', bbcode_uid),'')";

	$sql[] = "UPDATE " . DL_BUGS_TABLE . " SET bug_bitfield = 'x' WHERE report_text <> ''";
	$sql[] = "UPDATE " . DL_COMMENTS_TABLE . " SET com_bitfield = 'x' WHERE comment_text <> ''";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET desc_bitfield = 'x' WHERE description <> ''";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET long_desc_bitfield = 'x' WHERE long_desc <> ''";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET mod_desc_bitfield = 'x' WHERE mod_desc <> ''";
	$sql[] = "UPDATE " . DOWNLOADS_TABLE . " SET warn_bitfield = 'x' WHERE warning <> ''";
	$sql[] = "UPDATE " . DL_CAT_TABLE . " SET desc_bitfield = 'x' WHERE description <> ''";
	$sql[] = "UPDATE " . DL_CAT_TABLE . " SET rules_bitfield = 'x' WHERE rules <> ''";

	$sql[] = "DELETE FROM " . DL_CONFIG_TABLE . " WHERE config_name = 'dl_direct'";
	
	$db->return_on_error = true;
	for ($i = 0; $i < sizeof($sql); $i++)
	{
		$db->sql_query($sql[$i]);
	}
	$db->return_on_error = false;

	unset($sql);

	$umil->table_column_update(DL_BUGS_TABLE, 'report_text', array('MTEXT_UNI', ''));
	$umil->table_column_update(DL_COMMENTS_TABLE, 'comment_text', array('MTEXT_UNI', ''));
	$umil->table_column_update(DOWNLOADS_TABLE, 'description', array('MTEXT_UNI', ''));
	$umil->table_column_update(DOWNLOADS_TABLE, 'long_desc', array('MTEXT_UNI', ''));
	$umil->table_column_update(DOWNLOADS_TABLE, 'mod_desc', array('MTEXT_UNI', ''));
	$umil->table_column_update(DOWNLOADS_TABLE, 'warning', array('MTEXT_UNI', ''));
	$umil->table_column_update(DL_CAT_TABLE, 'description', array('MTEXT_UNI', ''));
	$umil->table_column_update(DL_CAT_TABLE, 'rules', array('MTEXT_UNI', ''));

	// Define basic table definitions for the converter
	$data_fields = array(
		DL_BUGS_TABLE.':report_id'	=> array('report_text' => 'bug'),
		DL_COMMENTS_TABLE.':dl_id'	=> array('comment_text' => 'com'),
		DOWNLOADS_TABLE.':id'		=> array('description' => 'desc', 'long_desc' => 'long_desc', 'mod_desc' => 'mod_desc', 'warning' => 'warn'),
		DL_CAT_TABLE.':id'			=> array('description' => 'desc', 'rules' => 'rules')
	);
	
	// Basic settings for reformat bbcodes
	$allow_bbcodes	= ($config['allow_bbcode']) ? true : false;
	$allow_urls		= true;
	$allow_smilies	= ($config['allow_smilies']) ? true : false;
	$uid = $bitfield = '';
	$flags = 0;

	// And now: The REAL convertor script!
	foreach($data_fields as $table_data => $value_ary)
	{
		foreach($value_ary as $text_field => $bbcode_field)
		{
			list($table, $id_field) = explode(':', $table_data);
			
			$sql = "SELECT $id_field, $text_field, {$bbcode_field}_uid FROM $table WHERE {$bbcode_field}_bitfield = 'x'";

			$result = $db->sql_query($sql);
	
			$total_rows = $db->sql_affectedrows($result);
	
			if ($total_rows)
			{
				while ($row = $db->sql_fetchrow($result))
				{
					$id = $row[$id_field];
					$text_content = utf8_encode($row[$text_field]);
		
					$uid = $bitfield = '';
					$flags = 0;

					// Format text with bbcodes and get the bbcode informations if needed
					if ($row[$bbcode_field.'_uid'] == 'x')
					{
						generate_text_for_storage($text_content, $uid, $bitfield, $flags, $allow_bbcodes, $allow_urls, $allow_smilies);
					}

					// Update the text with the new bbcode informations
					$sql = "UPDATE $table SET " . $db->sql_build_array('UPDATE', array(
						$text_field => $text_content,
						$bbcode_field . '_uid'		=> $uid,
						$bbcode_field . '_bitfield'	=> $bitfield,
						$bbcode_field . '_flags'	=> $flags)) . " WHERE $id_field = $id";
					$db->sql_query($sql);
				}
			}
	
			$db->sql_freeresult($result);
		}
	}

	$umil->table_column_remove(DL_BUGS_TABLE, 'report_uid');
	$umil->table_column_remove(DL_COMMENTS_TABLE, 'bbcode_uid');
	$umil->table_column_remove(DOWNLOADS_TABLE, 'bbcode_uid');
	$umil->table_column_remove(DL_CAT_TABLE, 'bbcode_uid');

	trigger_error('Download tables converted.<br />Please re-run now the file install.php from the Download MOD 6.x to complete the convertion');
}
else
{
	confirm_box(false, 'Please confirm if you are ready to convert the download tables');
}

// Shouldn't get here.
redirect($phpbb_root_path . $user->page['page_name']);

function dl_config_exists($config_name, $return_result = false)
{
	global $db, $umil, $config;

	if ($umil->table_exists(DL_CONFIG_TABLE))
	{
		$sql = 'SELECT config_value FROM ' . DL_CONFIG_TABLE . "
			WHERE config_name = '" . $db->sql_escape($config_name) . "'";
		$result = $db->sql_query($sql);
		$value = $db->sql_fetchfield('config_value');
		$db->sql_freeresult($result);
	
		if ($value)
		{
			return ($return_result) ? $value : true;
		}
	}

	return (isset($config[$config_name])) ? $config[$config_name] : false;
}

?>